package com.glxp.udidl.admin.controller.collect;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.pagehelper.PageInfo;
import com.glxp.udidl.admin.entity.collect.ThirdAliDrug;
import com.glxp.udidl.admin.enums.ResultEnum;
import com.glxp.udidl.admin.req.collect.ThirdAliDrugAddRequest;
import com.glxp.udidl.admin.req.collect.ThirdAliDrugRequest;
import com.glxp.udidl.admin.res.BaseResponse;
import com.glxp.udidl.admin.res.PageSimpleResponse;
import com.glxp.udidl.admin.service.collect.ThirdAliDrugService;
import com.glxp.udidl.admin.util.ResultVOUtils;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.util.List;

@RestController
public class ThirdAliDrugController {

    @Resource
    private ThirdAliDrugService thirdAliDrugService;

    @PostMapping("/udiwms/aliDrug/addThirdAliDrug")
        public BaseResponse addThirdAliDrug(@RequestBody @Valid ThirdAliDrugAddRequest relCodeBatchRequest, BindingResult bindingResult) {
        thirdAliDrugService.addThirdAliDrug(relCodeBatchRequest);
        return ResultVOUtils.success("添加成功！");
        }

    @GetMapping("/udiwms/aliDrug/getDrugLevelList")
    public BaseResponse getDrugLevelList(ThirdAliDrugRequest thirdAliDrug, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.DATA_REPEAT, bindingResult.getFieldError().getDefaultMessage());
        }


        if (StrUtil.isEmpty(thirdAliDrug.getApprovalNum()) && StrUtil.isEmpty(thirdAliDrug.getNameCode()) &&
                StrUtil.isEmpty(thirdAliDrug.getCpmctymc())&&
                StrUtil.isEmpty(thirdAliDrug.getManufacturer())
        ) {
            return ResultVOUtils.success("查询参数不能为空");
        }
        List<ThirdAliDrug> list = thirdAliDrugService.filterList(thirdAliDrug);
        PageInfo<ThirdAliDrug> pageInfo = new PageInfo<>(list);
        PageSimpleResponse<ThirdAliDrug> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(list);
        return ResultVOUtils.success(pageSimpleResponse);
    }

    @GetMapping("/udiwms/aliDrug/getDrugLevelListBycode")
    public BaseResponse getDrugLevelListBycode(ThirdAliDrugRequest thirdAliDrug, BindingResult bindingResult) {
        String nameCode = thirdAliDrug.getNameCode();
        if (StrUtil.isEmpty(nameCode)) {
            return ResultVOUtils.error(ResultEnum.DATA_REPEAT,"标识参数不能为空");
        }
        ThirdAliDrug one = thirdAliDrugService.getOne(new LambdaQueryWrapper<ThirdAliDrug>().eq(ThirdAliDrug::getNameCode, nameCode));
        if (one == null) {
            return ResultVOUtils.error(ResultEnum.DATA_REPEAT,"标识参数错误");
        }

        List<ThirdAliDrug> list = thirdAliDrugService.list(new LambdaQueryWrapper<ThirdAliDrug>()
                .eq(ThirdAliDrug::getApprovalNum, one.getApprovalNum())
                .eq(ThirdAliDrug::getCpmctymc, one.getCpmctymc())
                .eq(ThirdAliDrug::getForm, one.getForm())
                .eq(ThirdAliDrug::getBzgg, one.getBzgg())
                .eq(ThirdAliDrug::getPackRatio, one.getPackRatio()));

        return ResultVOUtils.success(list);
    }





    @GetMapping("/udiwms/aliDrug/111")
    public BaseResponse teest111() {
        thirdAliDrugService.updateThirdAliDrugTask();
        return ResultVOUtils.success();
    }

}
